# sprawdzamy katalog roboczy

getwd()

# ustawiamy nasz katalog roboczy

setwd("./inf")
getwd()

# wybieramy i pobieramy dane (plik CSV): 
# http://apps.who.int/gho/data/node.home
# dane zapisujemy w naszym katalogu roboczym
# Children aged <5 years underweight - Data by country

# wczytujemy dane do pamieci, wywolanie funkcji, argumenty, operator przypisania

data <- read.table("./xmart.csv", header=TRUE, sep=",", skip=1)

# wywietlamy kilka pierwszych wierszy
# sprawdzamy jakie dane zostay wczytane, wywietlamy nazwy "kolumn"

head(data)
names(data)

# modyfikujemy nazwy "kolumn", tak aby byy bardziej czytelne
# tworzenie wektora
# typy danych

class("36")
class(36)
class(36L)
class(36+0i)
class(TRUE)

names(data)
names(data) <- c("country","year","source","both","female","male")

# usuwamu informacje o rdle
# dostp do elementw wektora

v1 <- 3:0
v1

v1[1]
v1[length(v1)]
v1[c(T,T,T,F)]
v1[3:1]
v1[-2]

data <- data[-3]

# wywietlamy pierwsze wiersze danych pomiarowych

head(data)

# sprawdzamy typ danych

class(data)

# sprawdzamy typy poszczeglnych "kolumn"

str(data)

# modyfikujemy typy poszczeglnych danych
# konwrsja danych

data$country <- as.character(data$country)

data$year <- as.character(data$year)

data$male <- as.numeric(as.character(data$male))

# sprawdzamy jakie s typy po zmianie

str(data)

# sprawdzamy, czy mamy jakie brakujce dane
# wartoci specjalne
# tworzenie wektora
# sekwencja
# usuwanie brakujcych danych 

v2 <- c(0/0, 1/0, 1/Inf, TRUE, as.numeric("abc"))
v2

v4 <- vector("numeric", length=9)
v4[1:4] <- 1:4
v4[5] <- "null"
v4[6:9] <- 6:9
v4
class(v4)
v4 <- as.numeric(v4)
v4
bad <- is.na(v4)
bad
v4 <- v4[!bad]
v4

sum(!complete.cases(data))

# usuwamy wszystkie brakujce dane - zakdamy, e interesuj nas tylko kompletne informacje
# dostp do elementw data.frame
# ograniczanie elementw

data <- data[complete.cases(data),]

# rozdzielamy zakres dat np. 2009-2001 na 2 kolumny 
# jednoczenie jesli nie mamy doczynienia z zakresem wpisujemy w obie kolumny ten sam rok
# konstrukcja ptli for
# konstrukcja if-else
# tworzenie nowej kolumny

for(i in 1:nrow(data)) {
  tmp <- strsplit(data[i,"year"],"-")[[1]]
  data[i,"from"] <- tmp[1]
  if(is.na(tmp[2]))
    data[i,"to"] <- data[i,"from"]
  else
    data[i,"to"] <- tmp[2]
}

# tworzymy nowy data frame, ktry bdziemy uzupenia naszymi danymi pomiarowymi
# data.frame - tworzenie, rnica data.frame - macierz

data2<-data.frame(country=NA,
                  year=NA,
                  both=NA,
                  female=NA,
                  male=NA
)[0,]
data2

# uzupeniamy data frame danymi pomiarowymi

for(i in 1:nrow(data)) {
  for(j in data[i,"from"]:data[i,"to"]) {
    df <- data.frame(country=data[i,"country"],
           year=j,
          both=data[i,"both"],
          female=data[i,"female"],
          male=data[i,"male"]
    )
    
    data2<- rbind(data2, df)
    
  }
}

# sprawdamy efekt, zapisujemy stworzony data frame jako data, a nasz data2 (tymczasow zmiann) usuwamy

data2

data <- data2

rm(data2)

# sprawdzamy ktre kraje maj najmniejszy/najwikszy problem

data[data$both>50,]
data[data$both<1,]

# rysujemy histogram

hist(data$both, main="dzieci z niedowag", xlab = "%", col="red")

# kwantyle, min, mac, mediana, srednia

quantile(data$both,na.rm=T, probs=seq(0,1,0.1))
min(data$both)
max(data$both)
median(data$both)
mean(data$both)

# sprawdzamy ile danych mamy z poszczegolnych lat

table(data$year)

# rysujemy histogram tylko dla wybranego roku

hist(data[data$year==2000,]$both)

# grupujemy dane po roku licz redni

library(dplyr)
tmp <- data %>% group_by(year) %>% summarize(both = mean(both), female = mean(female), male = mean(male)) %>% arrange(desc(year)) 

# wynik przedstawiamy na wykresie

plot(tmp[[3]] ~ tmp[[4]])

# sprawdzamy korelacje 

cor(tmp[[3]], tmp[[4]])

# wyznaczamy regresje liniow

model <- lm(tmp[[3]] ~ tmp[[4]])
model

# rysujemy na wykresie lini regresji

abline(model, col="red", lwd="3")

# tworzymy schemat 1 aplikacji w shiny

library(shiny)

ui <- fluidPage(
  tags$h1("test"),
  tags$h1("test2"),
  tags$h1("test3")  
)
server <- function(input, output) {
}
shinyApp(ui=ui, server=server)

# dodajemy do aplikacji histogram

library(shiny)

ui <- fluidPage(
  
  selectInput(inputId = 'year', 
              label='Rok', 
              choices = sort(names(table(data$year))),
              selected = "2014"),
  plotOutput(outputId = 'plot')
)
server <- function(input, output) {
  output$plot <- renderPlot({
    hist(data[["both"]][data$year==input$year])
  })
}

shinyApp(ui=ui, server=server)

# dodajemy do aplikacji wykres

library(shiny)

library(dplyr)

ui <- fluidPage(
  
  selectInput(inputId = 'year', 
              label='Rok', 
              choices = sort(names(table(data$year))),
              selected = "2014"),
  plotOutput(outputId = 'plot'),
  plotOutput(outputId = 'plot2')
)
server <- function(input, output) {
  output$plot <- renderPlot({
    hist(data[["both"]][data$year==input$year])
  })
  
  output$plot2 <- renderPlot({
    plot(data[["female"]][data$year==input$year] ~ data[["male"]][data$year==input$year])                          
  })
}

shinyApp(ui=ui, server=server)


# dodajemy regresje liniowa

library(shiny)

library(dplyr)

ui <- fluidPage(
  
  selectInput(inputId = 'year', 
              label='Rok', 
              choices = sort(names(table(data$year))),
              selected = "2014"),
  plotOutput(outputId = 'plot'),
  plotOutput(outputId = 'plot2')
)
server <- function(input, output) {
  output$plot <- renderPlot({
    hist(data[["both"]][data$year==input$year])
  })
  
  output$plot2 <- renderPlot({
    plot(data[["female"]][data$year==input$year] ~ data[["male"]][data$year==input$year])
    model <- lm(data[["female"]][data$year==input$year] ~ data[["male"]][data$year==input$year])
    abline(model, col="red", lwd=3)
  })
}

shinyApp(ui=ui, server=server)

# dodajemy informacje o wspczynniku korelacji oraz wyznaczonej linii regresji


library(shiny)

library(dplyr)

ui <- fluidPage(
  
  selectInput(inputId = 'year', 
              label='Rok', 
              choices = sort(names(table(data$year))),
              selected = "2014"),
  plotOutput(outputId = 'plot'),
  textOutput(outputId = 'cor'),
  textOutput(outputId = 'model'),
  plotOutput(outputId = 'plot2')
)
server <- function(input, output) {
  model <- reactive({
    lm(data[["female"]][data$year==input$year] ~ data[["male"]][data$year==input$year])
  })
  
  
  output$plot <- renderPlot({
    hist(data[["both"]][data$year==input$year])
  })
  
  output$plot2 <- renderPlot({
    plot(data[["female"]][data$year==input$year] ~ data[["male"]][data$year==input$year])
    abline(model(), col="red", lwd=3)
  })
  
  output$model <- renderText({
    paste("y = ", round(model()$coefficients[2],2),
          " * x + ", round(model()$coefficients[1],2))
  })

  output$cor <- renderText({
    paste("Wspczynnik korelacji: ",
      round(cor(data[["female"]][data$year==input$year], data[["male"]][data$year==input$year]),2)
    )
  })
}

shinyApp(ui=ui, server=server)
